/* vi: set sw=4 ts=4: */
/*
 * KON2 - Kanji ON Console -
 * Copyright (C) 1992-1996 Takashi MANABE (manabe@papilio.tutics.tut.ac.jp)
 *
 * CCE - Console Chinese Environment -
 * Copyright (C) 1998-2003 Rui He (rhe@3eti.com)
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE TERRENCE R. LAMBERT BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 * 
 */

/* mouse.h -- mouse driver interface */
#ifndef	__CCE_MOUSE_H__
#define	__CCE_MOUSE_H__

#include	"defs.h"
#include    <sys/types.h>

#define MOUSE_LFT	4
#define MOUSE_MID	2
#define MOUSE_RGT	1
#define	MOUSE_LIFETIME	55		 /* 5.5 seconds */

struct mouseInfo 
{
	bool	has_mouse;
	int /*char*/	x, y, dx, dy, sx, sy, sw;  

	unsigned char stat;
};

typedef enum {
	MOUSE_MICROSOFT,
	MOUSE_MOUSESYSTEMS,
	MOUSE_BUSMOUSE,
	MOUSE_MMSERIES,
	MOUSE_LOGITECH,
	MOUSE_PS2,
#ifdef SUPPORT_GPMMOUSE
	MOUSE_GPM,  /* added for gpm server */
#endif
	MOUSE_NONE
} mtype;

extern mtype mouseType;

extern struct mouseInfo	mInfo;
extern int mouseFd;

extern void	MouseInit(void);
extern int	MouseAttach(void);
extern void MouseHandleEvent(int fd);
extern void MouseDetach(void);
extern void	MouseCleanup(void);

#endif /* __CCE_MOUSE_H__ */
